> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pnbr.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Traverse graph

> Walk the project graph from given nodes along typed edges.

**Operation ID:** `http.graph.traverse`

```http theme={null}
POST /v1/orgs/{org}/projects/{project}/graph/traverse
```


## OpenAPI

````yaml openapi.json POST /v1/orgs/{org}/projects/{project}/graph/traverse
openapi: 3.1.0
info:
  title: Penumbra API
  version: v1
  description: >-
    HTTP reference for Files, search, extraction, reviews, Graph, Shapes and
    sharing.
servers:
  - url: https://api.pnbr.io
    description: Penumbra API
security: []
paths:
  /v1/orgs/{org}/projects/{project}/graph/traverse:
    post:
      tags:
        - Graph
      summary: Traverse graph
      description: >-
        Walk the project graph from given nodes along typed edges.


        Product guidance: [Entity](/concepts/entity),
        [Relationship](/concepts/relationship).
      operationId: http.graph.traverse
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: project
          in: path
          required: true
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/http_graph_traverse_request'
      responses:
        2XX:
          description: Success.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/http_graph_traverse_response'
      security:
        - bearerAuth: []
components:
  schemas:
    http_graph_traverse_request:
      type: object
      properties:
        starting_node_ids:
          minItems: 1
          maxItems: 50
          type: array
          items:
            type: string
            format: uuid
            pattern: >-
              ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
        direction:
          default: outgoing
          type: string
          enum:
            - outgoing
            - incoming
            - both
        max_depth:
          default: 1
          type: integer
          minimum: 1
          maximum: 6
        max_nodes:
          default: 200
          type: integer
          minimum: 1
          maximum: 1000
        max_edges:
          default: 500
          type: integer
          minimum: 1
          maximum: 1000
        node_property_filters:
          default: []
          maxItems: 8
          type: array
          items:
            oneOf:
              - type: object
                properties:
                  key:
                    type: string
                  op:
                    type: string
                    const: eq
                  value:
                    anyOf:
                      - type: string
                      - type: number
                      - type: boolean
                      - type: 'null'
                required:
                  - key
                  - op
                  - value
                additionalProperties: false
              - type: object
                properties:
                  key:
                    type: string
                  op:
                    type: string
                    const: in
                  values:
                    minItems: 1
                    maxItems: 50
                    type: array
                    items:
                      anyOf:
                        - type: string
                        - type: number
                        - type: boolean
                        - type: 'null'
                required:
                  - key
                  - op
                  - values
                additionalProperties: false
              - type: object
                properties:
                  key:
                    type: string
                  op:
                    type: string
                    const: exists
                  value:
                    type: boolean
                required:
                  - key
                  - op
                  - value
                additionalProperties: false
              - type: object
                properties:
                  key:
                    type: string
                  op:
                    type: string
                    const: contains
                  value:
                    anyOf:
                      - type: string
                      - type: number
                      - type: boolean
                      - type: 'null'
                required:
                  - key
                  - op
                  - value
                additionalProperties: false
              - type: object
                properties:
                  key:
                    type: string
                  op:
                    type: string
                    enum:
                      - gt
                      - gte
                      - lt
                      - lte
                  value:
                    type: number
                required:
                  - key
                  - op
                  - value
                additionalProperties: false
        edge_property_filters:
          default: []
          maxItems: 8
          type: array
          items:
            oneOf:
              - type: object
                properties:
                  key:
                    type: string
                  op:
                    type: string
                    const: eq
                  value:
                    anyOf:
                      - type: string
                      - type: number
                      - type: boolean
                      - type: 'null'
                required:
                  - key
                  - op
                  - value
                additionalProperties: false
              - type: object
                properties:
                  key:
                    type: string
                  op:
                    type: string
                    const: in
                  values:
                    minItems: 1
                    maxItems: 50
                    type: array
                    items:
                      anyOf:
                        - type: string
                        - type: number
                        - type: boolean
                        - type: 'null'
                required:
                  - key
                  - op
                  - values
                additionalProperties: false
              - type: object
                properties:
                  key:
                    type: string
                  op:
                    type: string
                    const: exists
                  value:
                    type: boolean
                required:
                  - key
                  - op
                  - value
                additionalProperties: false
              - type: object
                properties:
                  key:
                    type: string
                  op:
                    type: string
                    const: contains
                  value:
                    anyOf:
                      - type: string
                      - type: number
                      - type: boolean
                      - type: 'null'
                required:
                  - key
                  - op
                  - value
                additionalProperties: false
              - type: object
                properties:
                  key:
                    type: string
                  op:
                    type: string
                    enum:
                      - gt
                      - gte
                      - lt
                      - lte
                  value:
                    type: number
                required:
                  - key
                  - op
                  - value
                additionalProperties: false
        node_types:
          minItems: 1
          maxItems: 50
          type: array
          items:
            type: string
            minLength: 1
            maxLength: 256
        edge_types:
          minItems: 1
          maxItems: 50
          type: array
          items:
            type: string
            minLength: 1
            maxLength: 256
      required:
        - starting_node_ids
      additionalProperties: false
    http_graph_traverse_response:
      type: object
      properties:
        data:
          type: object
          properties:
            starting_node_ids:
              type: array
              items:
                type: string
                format: uuid
                pattern: >-
                  ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
            nodes:
              type: array
              items:
                type: object
                properties:
                  id:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  type:
                    type: string
                    minLength: 1
                    maxLength: 256
                  name:
                    anyOf:
                      - type: string
                        maxLength: 1024
                      - type: 'null'
                  description:
                    anyOf:
                      - type: string
                        maxLength: 8192
                      - type: 'null'
                  properties:
                    description: Bounded JSON properties owned by the Graph resource.
                    type: object
                    propertyNames:
                      type: string
                    additionalProperties:
                      $ref: >-
                        #/components/schemas/http_graph_traverse_response____schema0
                  revision:
                    type: integer
                    exclusiveMinimum: 0
                    maximum: 9007199254740991
                  created_at:
                    type: string
                    format: date-time
                    pattern: >-
                      ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                  updated_at:
                    type: string
                    format: date-time
                    pattern: >-
                      ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                  deleted_at:
                    anyOf:
                      - type: string
                        format: date-time
                        pattern: >-
                          ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                      - type: 'null'
                required:
                  - id
                  - type
                  - name
                  - description
                  - properties
                  - revision
                  - created_at
                  - updated_at
                  - deleted_at
                additionalProperties: false
            edges:
              type: array
              items:
                type: object
                properties:
                  id:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  source_node_id:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  target_node_id:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  type:
                    type: string
                    minLength: 1
                    maxLength: 256
                  properties:
                    description: Bounded JSON properties owned by the Graph resource.
                    type: object
                    propertyNames:
                      type: string
                    additionalProperties:
                      $ref: >-
                        #/components/schemas/http_graph_traverse_response____schema0
                  revision:
                    type: integer
                    exclusiveMinimum: 0
                    maximum: 9007199254740991
                  created_at:
                    type: string
                    format: date-time
                    pattern: >-
                      ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                  updated_at:
                    type: string
                    format: date-time
                    pattern: >-
                      ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                  deleted_at:
                    anyOf:
                      - type: string
                        format: date-time
                        pattern: >-
                          ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                      - type: 'null'
                required:
                  - id
                  - source_node_id
                  - target_node_id
                  - type
                  - properties
                  - revision
                  - created_at
                  - updated_at
                  - deleted_at
                additionalProperties: false
            max_depth_reached:
              type: integer
              minimum: 0
              maximum: 9007199254740991
            truncated:
              type: boolean
            truncation_reason:
              anyOf:
                - type: string
                  enum:
                    - node_budget
                    - edge_budget
                - type: 'null'
          required:
            - starting_node_ids
            - nodes
            - edges
            - max_depth_reached
            - truncated
            - truncation_reason
          additionalProperties: false
      required:
        - data
      additionalProperties: false
    http_graph_traverse_response____schema0:
      anyOf:
        - type: string
        - type: number
        - type: boolean
        - type: 'null'
        - type: array
          items:
            $ref: '#/components/schemas/http_graph_traverse_response____schema0'
        - type: object
          propertyNames:
            type: string
          additionalProperties:
            $ref: '#/components/schemas/http_graph_traverse_response____schema0'
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.